From 40f99679a489ae47044528ffc32d6c49510cc116 Mon Sep 17 00:00:00 2001
From: Claude Heiland-Allen <claude@mathr.co.uk>
Date: Thu, 20 Sep 2018 08:35:35 +0100
Subject: [PATCH 18/39] support more number types in grid io

---
 src/formats.cxx | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

diff --git a/src/formats.cxx b/src/formats.cxx
index 054b9f54..cac5d2cb 100644
--- a/src/formats.cxx
+++ b/src/formats.cxx
@@ -148,7 +148,7 @@ Format::~Format () {_0_close();}
 struct GridHeader {
 	char magic[5]; // = "\x7fgrid" on little endian, "\x7fGRID" on big endian
 	uint8 type; // supported: 8=int8 9=uint8 16=int16 32=int32
-		    // unsupported: 34=float32 64=int64 66=float64
+		    // supported: 34=float32 64=int64 66=float64
 		   // (number of bits is multiple of 8; add 1 for unsigned; add 2 for float)
 	uint8 reserved; // set this to 0 all of the time.
 	uint8 dimn; // number of dimensions supported: at least 0..4)
@@ -216,6 +216,9 @@ struct GridHeader {
 		case 9: type=uint8_e; break;
 		case 16: type=int16_e; break;
 		case 32: type=int32_e; break;
+		case 34: type=float32_e; break;
+		case 64: type=int64_e; break;
+		case 66: type=float64_e; break;
 		default: RAISE("unsupported grid type %d in file",head.type);
 		}
 		// apparently, head.type 8 and 16 worked too.
@@ -249,6 +252,9 @@ GRID_INLET(0) {
 		case uint8_e: head.type = 9; break;
 		case int16_e: head.type = 16; break;
 		case int32_e: head.type = 32; break;
+		case float32_e: head.type = 34; break;
+		case int64_e: head.type = 64; break;
+		case float64_e: head.type = 66; break;
 		default: RAISE("can't write that type of number to a file");
 		}
 		head.reserved = 0;
-- 
2.19.1

